// 3.3.2005

// r0 : Startaddress for IMAGE RAM
// r1 : GPIO_IOCLR
// r2 : GPIO_IOSET
// r3 : Value represents all data bits
// r4 : contains index into Image RAM
// r5 : wr port bit
// r6 : nc 
// r7 : Lcd_Image_Lenght
// r8 : Value for output

	AREA "C$$code",CODE,READCODE
	EXPORT _Image2lcd

_Image2lcd:
		  mov r12,SP
		  stmdb SP!,{r0-r11,r13,LR}
		  mov r11,SP
		  
;r0 contains LCD_RAM_Image;		    //StartAddress of Image RAM
		  mov r3,r2;				//value of all data bits for clear port
          mov r7,r1;				//r7 contains Lcd_Image_Lenght;
          mov r1,#0x70000000
		  add r1,r1,r1
		  add r1,r1,#0x28000
		  mov r2,r1
		  add r1,r1,#0x0c;			//GPIO_IOCLR - Port Address Clear port
		  add r2,r2,#0x04;			//GPIO_IOSET - Port Address Set port
		  mov r4,#0;			    //R4 contains index into Image RAM
		  mov r5,#0x20000;		    //R5 contains write bit
;r6 gp register for add etc. -------
;r8 contains value to be outputed----
	 	  B loopend;		        //jump to loopende and check if end 

; entry for loop---------------------------------------------
loopstart: 
		 ldr r8,[r0,r4,LSL #2];	    //load value from Image RAM
		 add r4,r4,#1;		        //increment index

		 str r3,[r1];		        //clear port data
		 and r6,r8,#0x000000FF;     //mask first byte 
		 mov r6,r6,LSL #19;	        //shift value to right position
		 str r6,[r2];		        //set port with current data
		 str r5,[r1];		        //write = 0
		 str r5,[r2];		        //write = 1

		 str r3,[r1];		        //clear port data
		 and r6,r8,#0x0000FF00;	    //mask first byte 
		 mov r6,r6,LSL #11;	        //shift value to right position
		 str r6,[r2];		        //set port with current data
		 str r5,[r1];		        //write = 0		 
		 str r5,[r2];		        //write = 1

		 str r3,[r1];		        //clear port data
		 and r6,r8,#0x00FF0000;	    //mask first byte 
		 mov r6,r6,LSL #3;		    //shift value to right position
		 str r6,[r2];		        //set port with current data
		 str r5,[r1];		        //write = 0
	     str r5,[r2];		        //write = 1
	 
		 str r3,[r1];		        //clear port data
		 and r6,r8,#0xFF000000;	    //mask first byte 
		 mov r6,r6,LSR #5;		    //shift value to right position
		 str r6,[r2];		        //set port with current data
		 str r5,[r1];		        //write = 0
		 str r5,[r2];               //write = 1	 
//----
		 ldr r8,[r0,r4,LSL #2];	    //load value from Image RAM
		 add r4,r4,#1;		        //increment index

		 str r3,[r1];		        //clear port data
		 and r6,r8,#0x000000FF;     //mask first byte 
		 mov r6,r6,LSL #19;	        //shift value to right position
		 str r6,[r2];		        //set port with current data
		 str r5,[r1];		        //write = 0
		 str r5,[r2];		        //write = 1

		 str r3,[r1];		        //clear port data
		 and r6,r8,#0x0000FF00;	    //mask first byte 
		 mov r6,r6,LSL #11;	        //shift value to right position
		 str r6,[r2];		        //set port with current data
		 str r5,[r1];		        //write = 0		 
		 str r5,[r2];		        //write = 1

		 str r3,[r1];		        //clear port data
		 and r6,r8,#0x00FF0000;	    //mask first byte 
		 mov r6,r6,LSL #3;		    //shift value to right position
		 str r6,[r2];		        //set port with current data
		 str r5,[r1];		        //write = 0
	     str r5,[r2];		        //write = 1
	 
		 str r3,[r1];		        //clear port data
		 and r6,r8,#0xFF000000;	    //mask first byte 
		 mov r6,r6,LSR #5;		    //shift value to right position
		 str r6,[r2];		        //set port with current data
		 str r5,[r1];		        //write = 0
		 str r5,[r2];               //write = 1
//----
		 ldr r8,[r0,r4,LSL #2];	    //load value from Image RAM
		 add r4,r4,#1;		        //increment index

		 str r3,[r1];		        //clear port data
		 and r6,r8,#0x000000FF;     //mask first byte 
		 mov r6,r6,LSL #19;	        //shift value to right position
		 str r6,[r2];		        //set port with current data
		 str r5,[r1];		        //write = 0
		 str r5,[r2];		        //write = 1

		 str r3,[r1];		        //clear port data
		 and r6,r8,#0x0000FF00;	    //mask first byte 
		 mov r6,r6,LSL #11;	        //shift value to right position
		 str r6,[r2];		        //set port with current data
		 str r5,[r1];		        //write = 0		 
		 str r5,[r2];		        //write = 1

		 str r3,[r1];		        //clear port data
		 and r6,r8,#0x00FF0000;	    //mask first byte 
		 mov r6,r6,LSL #3;		    //shift value to right position
		 str r6,[r2];		        //set port with current data
		 str r5,[r1];		        //write = 0
	     str r5,[r2];		        //write = 1
	 
		 str r3,[r1];		        //clear port data
		 and r6,r8,#0xFF000000;	    //mask first byte 
		 mov r6,r6,LSR #5;		    //shift value to right position
		 str r6,[r2];		        //set port with current data
		 str r5,[r1];		        //write = 0
		 str r5,[r2];               //write = 1	 
//----
		 ldr r8,[r0,r4,LSL #2];	    //load value from Image RAM
		 add r4,r4,#1;		        //increment index

		 str r3,[r1];		        //clear port data
		 and r6,r8,#0x000000FF;     //mask first byte 
		 mov r6,r6,LSL #19;	        //shift value to right position
		 str r6,[r2];		        //set port with current data
		 str r5,[r1];		        //write = 0
		 str r5,[r2];		        //write = 1

		 str r3,[r1];		        //clear port data
		 and r6,r8,#0x0000FF00;	    //mask first byte 
		 mov r6,r6,LSL #11;	        //shift value to right position
		 str r6,[r2];		        //set port with current data
		 str r5,[r1];		        //write = 0		 
		 str r5,[r2];		        //write = 1

		 str r3,[r1];		        //clear port data
		 and r6,r8,#0x00FF0000;	    //mask first byte 
		 mov r6,r6,LSL #3;		    //shift value to right position
		 str r6,[r2];		        //set port with current data
		 str r5,[r1];		        //write = 0
	     str r5,[r2];		        //write = 1
	 
		 str r3,[r1];		        //clear port data
		 and r6,r8,#0xFF000000;	    //mask first byte 
		 mov r6,r6,LSR #5;		    //shift value to right position
		 str r6,[r2];		        //set port with current data
		 str r5,[r1];		        //write = 0
		 str r5,[r2];               //write = 1

; loop end -------------------------------------------------------

loopend: cmp r4,r7;	                //compare if end reached
   		 bcc loopstart;	    	    //jump back if not end
         ldmia R11,{r0-r11,r13,PC};
		 
   		end
		
